

/**
 * @author Online Jam Space Group
 *
 * JamClient is the integrator of all midi and network modules.
 */
package OJS.Integration;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.Receiver;
import javax.sound.midi.ShortMessage;
import javax.sound.midi.Synthesizer;
import javax.swing.*;

import java.awt.event.*;
import java.awt.*;
import java.util.ArrayList;
import OJS.Network.*;
import OJS.Midi.*;

public class JamClient extends Thread{
	public final static int INSERT = 0, UPDATE = 1, DELETE = 2; //added by kinson
	Network n;
	MidiNoteLoop m; 
	MidiIoController c;
    int viewState;
    Welcome w;
    int WELCOME_WINDOW = 1;  //Enumerated states for the viewd
    int PLAYER_LIST    = 2;
    int CONNECTED      = 3;
    
    
    /**Default Contructor*/
	public JamClient(){
			  c = new MidiIoController();
			  n = new Network(); 
			  c.setNetwork(n);
			  n.setMidi(c);
			//  GUI g = new GUI();
			  w = new Welcome();
	}
	
	
	/**
	 * Controls threading issues.
	 */
	public void run(){
		try{
			while(true){
			Thread.sleep(500);
			//System.out.println("I eat beef"); //Just making sure threading works
			}
		}
	   catch(InterruptedException e){
	   	   System.out.println("Interuppted");
	   }
	}
	
	

	/**
	 * Instantiates a new timer object.
	 */
	public void startTimer(){
		new Timer(4000, w).start();

	}
	
	
	/**
	 * This is only for debugging purposes.
	 */
	public void respond(){
	 System.out.println("RESPONSE!");
	}
	
	
	public void welcome(){
	Welcome w = new Welcome();	
	}

	class GUI extends JFrame implements ActionListener{
		JTextField connectField;
		JTextField transmitField;
		JEditorPane   displayArea;
		public GUI(){
			this.setSize(300,600);
			connectField = new JTextField();
			transmitField = new JTextField();
			//textField.setPreferredSize( new Dimension(this.getWidth()-10, 20));
			JButton connectButton = new JButton("Connect");
		    connectButton.setActionCommand("connect");
			connectButton.addActionListener(this);
			
			JButton transmitButton = new JButton("Transmit");
		    transmitButton.setActionCommand("transmit");
			transmitButton.addActionListener(this);

			JButton playButton = new JButton("Play");
		    playButton.setActionCommand("play");
			playButton.addActionListener(this);
						
			JPanel temp = new JPanel();
			temp.setLayout(new  BorderLayout());

			Container c1 = new Container();
			c1.setSize(new Dimension( (int)(this.getWidth()/2.0), 20));
			c1.setLayout(new BorderLayout());
			c1.add(connectButton, BorderLayout.NORTH);
			c1.add(connectField, BorderLayout.CENTER);
		
			Container c2 = new Container();
			c2.setSize(new Dimension( (int)(this.getWidth()/2.0), 60));
			c2.setLayout(new BorderLayout());
			c2.add(transmitButton, BorderLayout.NORTH);
			c2.add(transmitField, BorderLayout.CENTER);

			Container c4 = new Container();
			c4.setSize(new Dimension( (int)(this.getWidth()/2.0), 60));
			c4.setLayout(new BorderLayout());
			c4.add(playButton, BorderLayout.NORTH);
			
			Container c3 = new Container();
			c3.setLayout(new BorderLayout());
			c3.add(c2, BorderLayout.WEST);
			c3.add(c1, BorderLayout.EAST);
			c3.add(c4, BorderLayout.SOUTH);
			
			displayArea = new JEditorPane();
			displayArea.setPreferredSize( new Dimension(this.getWidth(), 90));
			displayArea.setBackground(Color.WHITE);
			
			temp.add(displayArea, BorderLayout.SOUTH);
			temp.add(c3, BorderLayout.NORTH);
			
			temp.validate();
			temp.setVisible(true);
			this.setContentPane(temp);
		
			this.pack();
			this.validate();
			this.setVisible(true);
			this.setSize(300,600);
			
		}
		public void dispose(){
			super.dispose();
			System.out.println("DISPOSED!!!)");
			n.disconnect();
		}
		public void display(String info){
		//JOptionPane.showMessageDialog(this,info);
			displayArea.setText(info);
		}
		public void actionPerformed(ActionEvent e){
			if(e.getActionCommand().equals("connect")){
				String [] x = connectField.getText().split(" ");
				
				if(x.length < 2)
					return;
				try{
				n.connectToPeer(x[0], Integer.valueOf(x[1]).intValue());
				}
				catch(NumberFormatException exp){
					JOptionPane.showMessageDialog(this,"Syntax: 'IP PORT'\nFor example: 232.94.35.74 1024");
				}
			}
			else if(e.getActionCommand().equals("transmit")){
				try{
				 Synthesizer synth = MidiSystem.getSynthesizer();
				 synth.open();
				 Receiver r = synth.getReceiver();
				 m = new MidiNoteLoop(n);
				 m.setReceiver(r);
				 m.start();
				}
				catch(Exception err){}
			}
			else if(e.getActionCommand().equals("play")){
				ShortMessage onMessage = null;
				ShortMessage offMessage = null;
				try{
					
						try 
						{		
							onMessage = new ShortMessage();
							offMessage = new ShortMessage();
							//out("setting on message...");	
							onMessage.setMessage(ShortMessage.NOTE_ON, 0, 60, 120);
							//out("set off message...");
							offMessage.setMessage(ShortMessage.NOTE_OFF, 0, 60, 0);
							//out("set on message...");
							//out("On Msg: " + onMessage.getStatus() + " " + onMessage.getData1() + " " + onMessage.getData2());
							//out("Off Msg: " + offMessage.getStatus() + " " + offMessage.getData1() + " " + offMessage.getData2());
										
						}
						catch (InvalidMidiDataException e1)
						{
						}
						
						c.play(onMessage, -1);
						n.bufferMidi(onMessage, -1);
					//	try
						{
							//Thread.sleep(1000); // wait for a second
						}
						//catch (InterruptedException e2)
						{
						}
						c.play(offMessage,-1);
						n.bufferMidi(offMessage, 20);
					}
					catch(Exception err){}
			}	
		}
	}
	
	
	class Welcome extends JFrame 
		implements ActionListener {

		/* Instance Var. */
		private JTextField screenname, imhandle;
		private JComboBox instrument, imclient;
		String sn      = "";
		String instr   = "";
		String iclient = "";
		String ihandle = "";
		PlayerList pl;
		
		public Welcome() {

			super("Welcome to Online Jam Space");
			
			this.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) { System.exit(0); }
				});
	
			this.getContentPane().setLayout(new GridLayout(0,1,10,10));
	
			/** Add components */
			JLabel mainlabel = new JLabel("Enter Profile");
			
			JPanel snpanel = new JPanel();
			JLabel snlabel = new JLabel("Screenname");
			screenname = new JTextField("",10);
			snpanel.add(snlabel);
			snpanel.add(screenname);
	
			JPanel inpanel = new JPanel();
			JLabel inlabel = new JLabel("Instrument");
			String[] instruments = {"Guitar", "Keyboard", "Drums", "Bass"};
			instrument = new JComboBox(instruments);
			inpanel.add(inlabel);
			inpanel.add(instrument);
	
			JPanel impanel = new JPanel();
			JLabel imlabel = new JLabel("IM Client");
			String[] imclients = {"AIM", "MSN", "ICQ", "YAHOO", "IRC"};
				imclient = new JComboBox(imclients);
			impanel.add(imlabel);
			impanel.add(imclient);
	
			JPanel hapanel = new JPanel();
			JLabel halabel = new JLabel("IM Handle");
			imhandle = new JTextField("",10);
			imhandle.addActionListener(this);
			hapanel.add(halabel);
			hapanel.add(imhandle);
	
			JPanel buttons = new JPanel();
			JButton exit = new JButton("Exit");
			JButton next = new JButton("Next");
			exit.addActionListener(this);
			next.addActionListener(this);
			buttons.add(exit);
			buttons.add(next);
	
			this.getContentPane().add(mainlabel);
			this.getContentPane().add(snpanel);
			this.getContentPane().add(inpanel);
			this.getContentPane().add(impanel);
			this.getContentPane().add(hapanel);
			this.getContentPane().add(buttons);
	
			this.setSize(300, 350);
			this.setVisible(true);

		} 
	 
		/**
		 * Listener for the Welcome Screen.  
		 * @param e the event
		 */
		public void actionPerformed(ActionEvent e) {
		
		if(e.getActionCommand() == null){ ///TIMER EVENT
			try{
				n.sendToServer(JamClient.UPDATE, sn, instr, iclient, ihandle);
				if(pl != null)
					pl.refresh();
				}
				catch(Exception err){
				System.out.println("Server Update error" + err.getMessage());
				}
		}
		else if(e.getActionCommand().equals("Next")) {
			if(screenname.getText().equals("") || imhandle.getText().equals("")){
				JOptionPane.showMessageDialog(this, "Please fill in all fields.");
			}
			else{
				sn = screenname.getText();
				instr = (String)instrument.getSelectedItem();
				iclient = (String)imclient.getSelectedItem();
				ihandle = imhandle.getText();


				
				try{
					//to do: parse this string and look for user string or error
					String[][] result = n.sendToServer(JamClient.INSERT, sn, instr, iclient, ihandle);
					if(result == null)
						JOptionPane.showMessageDialog(this, "Connection failed.  Please try again.");
					else if(result[0][0].equals("-1")){
						this.setVisible(false);
						pl = new PlayerList(result,sn,instr, iclient, ihandle); 
						 startTimer();
					}
					else{
						this.setVisible(false);
						startTimer(); //Start Timer
					   pl = new PlayerList(result,sn,instr, iclient, ihandle);  
					}
				}
				catch(Exception esgfd){
					System.out.println("Exception while connecting to server" + esgfd.getMessage());
				}
			}
		}
	}
  }
	
	class PlayerList extends JFrame implements ActionListener {
    
    private MutableList people;
    private String sn, instr, iclient, ihandle;
    private String[][] userList; //ip port username instrument aim handle
    public PlayerList(String[][] userList, String sn, String instr, String iclient, String ihandle) {
    	super("Online Jam Space");
    
    	this.sn = sn;
    	this.instr = instr;
    	this.iclient = iclient;
    	this.ihandle = ihandle;
    	if(userList != null)
    		this.userList = userList;
    	else 
    		userList = null;

    	
    	this.addWindowListener(new WindowAdapter() {
    		public void windowClosing(WindowEvent e) { 
    			System.exit(0);
    			//to do: close all network connections
    		}
	    });

    	this.setLayout(new GridBagLayout());
    	GridBagConstraints g = new GridBagConstraints();
    	g.fill = GridBagConstraints.BOTH;
    	g.insets = new Insets(5,5,5,5);

	
    	/** Components */
    	
    	JLabel online_users = new JLabel("Online Users:");
	
		people = new MutableList();
		this.refresh();
		people.setFixedCellWidth(250);

		JButton connect = new JButton("Connect");
		JButton refresh = new JButton("Refresh"); 
		connect.addActionListener(this);
		refresh.addActionListener(this);
		
		g.gridx = 0; g.gridy = 0; g.gridwidth = 1; g.gridheight = 1;
    	g.weightx = g.weighty = 0.0;
    	this.getContentPane().add(online_users, g);
	
		g.gridx = 0; g.gridy = 1; g.gridwidth = 2; g.gridheight = 8;
    	g.weightx = g.weighty = 1.0;
    	this.getContentPane().add(people, g);
    	
    	g.gridx = 0; g.gridy = 9; g.gridwidth = 1; g.gridheight = 1;
    	g.weightx = g.weighty = 0.0;
    	this.getContentPane().add(connect, g);
    	
    	g.gridx = 1; g.gridy = 9; g.gridwidth = 1; g.gridheight = 1;
    	g.weightx = g.weighty = 0.0;
    	this.getContentPane().add(refresh, g);
	
    	this.setSize(200, 500);
    	this.setVisible(true);
    	
		
    }
    
    /**
	 * Listener for the PlayerList Screen.  
	 * @param e the event
	 */
    public void actionPerformed(ActionEvent e) {
    	if(e.getActionCommand().equals("Refresh")) {
    		this.refresh();
    	}else{
    		if(this.connect((String)people.getSelectedValue())) {
    			//connection succeeded, start jamming
    			Connected cn = new Connected(this.sn, (String)people.getSelectedValue());
    		}else{
    			//connection failed, go back
    			JOptionPane.showMessageDialog(this, "Connection with " + (String)people.getSelectedValue() + " could not be established.  Please try again later.");
    		}
    		
    	}
    }

    /**Attempt connection to a user 
     * @param user
     * @return true if connection succeeded or false otherwise
     */
    public boolean connect(String user) {
    	if(userList == null || userList[0][0].equals("-1"))
    		return false;
    	/** Ask network component to establish connection with user */
    	for(int i = 0; i < userList.length; i++){
    		if(userList[i][2].equals(user)){
    			n.connectToPeer(userList[i][0], Integer.valueOf(userList[i][1]).intValue());
    			return true;
    		}
    	}
    	
    	/** take out later */
    	return false;
    	/** end of take out */
    }
    
   
    /**
     * Refresh player list.
     */
    public void refresh(){
    	/**First, clear the JList and the ArrayList*/
    	people.getContents().clear();
    	try{
    	userList = n.sendToServer(JamClient.UPDATE, sn, instr, iclient, ihandle);
    	}
    	catch(Exception e){
    		System.out.println(e.getMessage());
    		
    	}
    	if(userList == null || userList[0][0].equals("-1"))
    		return;
    	else		
    		for(int i = 0; i < userList.length; i++){
    			people.getContents().addElement(userList[i][2]);
    	}
    	
    }
    
    
    /**
     * Handles an incoming connection request from another user.
     * @param potential_partner info of the person who is trying to initiate a connection.
     * @return true if accept, false if decline
     */
    public boolean incoming_request(String potential_partner) {
    	
        JOptionPane pane = new JOptionPane(potential_partner + " wants to jam.  Establish a connection?");
        Object[] options = new String[] { "YES", "NO" };
        pane.setOptions(options);
        JDialog dialog = pane.createDialog(new JFrame(), "Dilaog");
        dialog.setVisible(true);
        Object obj = pane.getValue(); 
        int result = -1;
        for (int k = 0; k < options.length; k++)
        if (options[k].equals(obj))
          result = k;
        if(result == 0) {
        	System.out.println("Yes selected.");
        	Connected cn = new Connected(this.sn, potential_partner);
        	return true;
        }else{
        	System.out.println("No selected.");
        	return false;
        }
    }
    
    
    
	    /**Inner class MutableList allows easy insertion and deletion*/
	    class MutableList extends JList {
	        MutableList() {
	    	super(new DefaultListModel());
	        }
	        DefaultListModel getContents() {
	    	return (DefaultListModel)getModel();
	        }
	    }   
    
    
}
	public class Connected extends JFrame 
	implements ActionListener, KeyListener{
    
	/* Instance Var. */
    
	public Connected(String me, String partner) {
    
		super("Jamming...");

		this.getContentPane().setLayout(new GridLayout(0,1,10,10));
    
		/** Add components */
		JPanel jp1 = new JPanel();
		jp1.add(new JLabel("My Screenname: "));
		jp1.add(new JLabel(me));
		this.getContentPane().add(jp1);
		
		JPanel jp2 = new JPanel();
		jp2.add(new JLabel("My Partner's Screenname: "));
		jp2.add(new JLabel(partner));
		this.getContentPane().add(jp2);
		
		JPanel jp3 = new JPanel();
		JButton disconnect = new JButton("Disconnect");
		disconnect.addActionListener(this);
		jp3.add(disconnect);
		this.getContentPane().add(jp3);
		
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		JTextField x = new JTextField("Type here to play");
		x.addKeyListener(this);
		this.getContentPane().add(x);
		this.setSize(250, 200);
		this.setVisible(true);
		this.getContentPane().addKeyListener(this);
    
	} 
    
	/**
	 * Listener for the Connected Screen.  
	 * @param e the event
	 */
	public void actionPerformed(ActionEvent e) {
    
		if(e.getActionCommand().equals("Disconnect")) {
			
			/**Tell network to disconnect */
			//fill me in
			
			System.out.println("Disconnect");
			this.dispose();
			
		}
    
	}
	public void keyReleased(KeyEvent k){
		}
	
	public void keyTyped(KeyEvent k){
		}
	
	public void keyPressed(KeyEvent k){
		switch(k.getKeyChar()){
		
		case('a'):
			playNote(60);
			break;	
		case('w'):
			playNote(61);
			break;		
		case('s'):
			playNote(62);
			break;		
		case('e'):
			playNote(63);
			break;	
		case('d'):
			playNote(64);
			break;		
		case('f'):
			playNote(65);
			break;	
		case('t'):
			playNote(66);
			break;	
		case('g'):
			playNote(67);
			break;		
		case('y'):
			playNote(68);
			break;		
		case('h'):
			playNote(69);
			break;	
		case('u'):
			playNote(70);
			break;		
		case('j'):
			playNote(71);
			break;	
		case('k'):
			playNote(72);
			break;	
		case('o'):
			playNote(73);
			break;	
		case('l'):
			playNote(74);
			break;		
		case('p'):
			playNote(75);
			break;		
		case(';'):
			playNote(76);
			break;	
			default:

			break;	
		}
		}
    public void playNote(int note){
    	ShortMessage onMessage = null;
		ShortMessage offMessage = null;
		try{
			
				try 
				{		
					onMessage = new ShortMessage();
					offMessage = new ShortMessage();

					onMessage.setMessage(ShortMessage.NOTE_ON, 0, note, 120);
					offMessage.setMessage(ShortMessage.NOTE_OFF, 0, note, 0);
				}
				catch (InvalidMidiDataException e1)
				{
				}
				
				c.play(onMessage, -1);
				n.bufferMidi(onMessage, -1);
				c.play(offMessage,-1);
				n.bufferMidi(offMessage, 20);
			}
			catch(Exception err){}
    	}
	}
}

