package OJS.Midi;


import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.Receiver;
import javax.sound.midi.Transmitter;
import javax.sound.midi.ShortMessage;
import java.util.Date;
import OJS.Network.*;

public class MidiNoteLoop extends Thread
	implements  Transmitter
{
	Receiver output = null;
	Network n;
	public MidiNoteLoop (Network n)
	{
		this.n = n;
	}
	
	
	public void run () 
	{
		ShortMessage onMessage = null;		
	    ShortMessage offMessage = null;
	    int base = 50;
	    for (int i= base;i<= base+8;i++)
	    {
			try 
			{		
				onMessage = new ShortMessage();
				offMessage = new ShortMessage();
				//out("setting on message...");	
				onMessage.setMessage(ShortMessage.NOTE_ON, 0, i, 120);
				//out("set off message...");
				offMessage.setMessage(ShortMessage.NOTE_OFF, 0, i, 0);
				//out("set on message...");
				//out("On Msg: " + onMessage.getStatus() + " " + onMessage.getData1() + " " + onMessage.getData2());
				//out("Off Msg: " + offMessage.getStatus() + " " + offMessage.getData1() + " " + offMessage.getData2());
							
			}
			catch (InvalidMidiDataException e)
			{
			}
			
			//out("sending on message...");
			Date s = new Date();
			output.send(onMessage, s.getTime());
			n.bufferMidi(onMessage, s.getTime());
			try
			{
				Thread.sleep(50); // wait for a second
			}
			catch (InterruptedException e)
			{
			}
			output.send(offMessage, s.getTime());
			n.bufferMidi(offMessage, s.getTime());
			//out("sending off message...");
			
			if(i == 80){
				
				
				base = 50;
				i = 50;
			}
			
			if(i == base+8){
				base +=2;
				i = base;
			}
			
	    }

		output.close();
	}
	
	public void setReceiver(Receiver r)
	{
		output = r;
	}
	
	public Receiver getReceiver()
	{
		return output;
	}
	
	public void close()
	{
		output.close();
	}
	
	private static void out(String strMessage)
	{
		System.out.println(strMessage);
	}	
}
