/*
 * Created on Jul 26, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author adumovic
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package OJS.Midi;
import javax.sound.midi.*;
import java.sql.Timestamp;
import OJS.Network.Network;

public class MidiSnapShot {
	int MAX_NOTES = 64;
	int size = 0;
	public ShortMessage []  messages = new ShortMessage[MAX_NOTES];
	int [] times = new int [MAX_NOTES];
	
	public MidiSnapShot(){
	}
	
	public MidiSnapShot(ShortMessage[] messages, int [] times){
		this.times = times;
		this. messages = messages;
		size = messages.length;
	}
	public void add(ShortMessage m, long t){
		//TODO Implement adding, how do we decode a midi message??????
		int time = (int) t; 
		messages[size] = m;
		times[size] = time;
		if(size < MAX_NOTES-1)
			size++;
		else
			System.out.println("Truncating midimessage: More than: "+ MAX_NOTES +" per 8ms interval!");
	}
	public void remove(int noteNumber){
		for(int i = 0; i < size; i++){
			if(messages[i].getData1() == noteNumber){
				for(int j = i; j < size-1; j++){
					messages[i] = messages[i+1];
					times[i] = times[i+1];
				}
				break;
			}
		}
	}
	public int getSize(){
		return size;
	}
	
	public void setSize(int newValue){
		size = newValue;
	}
	public byte[] encode(){

		byte[] data = new byte[size*8+2];
		data[0] = Network.MIDI_INFO_PACKET; //Set type
		data[1] = (byte)size; //Set number notes in snapshot
		for(int i = 0; i < size*8; i+=8){
			//System.out.println("Before convertion to bytes: " +times[i/8]);
			data[2+i]   = (byte) messages[i/8].getCommand();
		//	System.out.println(messages[i/8].getCommand()+" "+messages[i/8].getChannel()+" "+messages[i/8].getData1()+" "+messages[i/8].getData2());
			data[2+i+1] = (byte) messages[i/8].getChannel();
			data[2+i+2] = (byte) messages[i/8].getData1();
			data[2+i+3] = (byte) messages[i/8].getData2();
	
			data[2+i+4] = (byte) (times[i/8] >>> 24 & 0x07f);
		//	System.out.println((int)data[2+i+4]);
			data[2+i+5] = (byte) (times[i/8] >>> 16 & 0x0ff);
		//	System.out.println((int)data[2+i+5]);
			data[2+i+6] = (byte) (times[i/8] >>> 8 & 0x0ff);
		//	System.out.println((int)data[2+i+6]);
			data[2+i+7] = (byte) (times[i/8] & 0x0ff);
		//	System.out.println((int)data[2+i+7]);
			
		}
		return data;
	}
	
	public  MidiSnapShot decode(byte[] data) {
		ShortMessage [] messages = new ShortMessage[data[1]];
		int [] timing = new int[data[1]];
	
		for(int i = 0; i < data[1]; i++){
			try{
				messages[i] = new ShortMessage();
				messages[i].setMessage((data[2+i*8] & 0x0ff),   (data[2+i*8+1] & 0x0ff), 
						               (data[2+i*8+2] & 0x0ff), (data[2+i*8+3] & 0x0ff));
			}
			catch(InvalidMidiDataException e){
				System.out.println("midi byte decoding error: " +e.getMessage());
			}
			timing[i] =   data[2+i+7] | (data[2+i+6] << 8) | (data[2+i+5] << 16) | (data[2+i+4] << 24);
			//System.out.println("After Convertion: " +timing[i]);
		}
		return new MidiSnapShot(messages, timing);
	}
}
