/**
 * Set up the database
 * A test case for this class is not necessary.
 * If no exception is thrown during execution, it's workinly expectedly.
 */

import java.sql.*;
import java.io.*;

public class ServerSetup{
	String driver, server, db, table, url, user, pass;
	public ServerSetup() throws Exception{
		init();
		setup();
	}
	
	private void init() throws Exception{
		/*	Sample Input:
		 	DB_Driver = "jdbc:mysql";
		 	DB_Server = "abstract";
	 		DB_DB = "yanyin_JamSpace";
	 		DB_Table = "OnlineList";
	 		DB_URL = DB_Driver+"://"+DB_Server+"/"+DB_DB;
	 		DB_User = "yanyin";
	 		DB_Pass = "xxxxxxxxxx";
 		*/
		BufferedReader f = new BufferedReader(new FileReader(new File(".server.conf")));
		String line;
		int i = 0;
		while((line = f.readLine()) != null){
			int semiColon = line.indexOf(":");
			if(semiColon == -1) throw new ServerException("Configuration file is corrupted");
			switch(i){
				case 0:
					driver = line.substring(semiColon+1).trim();
					break;				
				case 1:	
					server = line.substring(semiColon+1).trim();
					break;	
				case 2:
					db = line.substring(semiColon+1).trim();
				break;
				case 3:
					table = line.substring(semiColon+1).trim();
				break;
				case 4:
					user = line.substring(semiColon+1).trim();
				break;			
				case 5:
					pass = line.substring(semiColon+1).trim();
				break;				
				default:
					throw new ServerException("Configuration file is corrupted");
			}
			i++;			
		}	
		url = driver+"://"+server+"/"+db;
		if(driver == null || server == null || db == null || table == null || url == null || user == null || pass == null)
			throw new ServerException("Configuration file is corrupted");
	}
	
	private void setup(){
		try{
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			Connection con = DriverManager.getConnection(url, user, pass);
			Statement s = con.createStatement();
			String SQLQuery = "create table if not exists "+table+" "+
									"(IP varchar(15) not null, "+
									"Port smallint unsigned not null, "+
									"nickname varchar(255) not null, "+
									"instrument varchar(255) not null, "+
									"IMClient varchar(255) not null, "+
									"IMHandle varchar(255) not null, "+
									"lastModified timestamp default null);";
			s.execute(SQLQuery);
			System.out.println("Table "+table+" [if not exists] has been sucessfully created");
		}
		catch(Exception e){
			System.out.print("Fatal Error: "+e.getMessage());
		}
	}
	
	public static void main(String argv[]) throws Exception{
		new ServerSetup();
	}
}
